int sense_pin = A0; //     ( ,   )
int sense_max = 500; //    ,   . ,    500 =  200 
int pwm_pin = 2; //    ( ,  )
int pwm_freq = 40000; //     00 

int pins[] = { A4, 8, 9, 10, A3, A2, A1, 13, 12, 11 }; //   .    ""     A5
int pos_pins[] = { 4, 5, 6, 7 }; //   
int numbers[] = { 0, 0, 0, 0 };

void setup(){
	Serial.begin(9600);
	Serial.setTimeout(50);
	//         .   
	//Serial.setTimeout(350);
	//Serial.print("AT+NAMEnixieClock");
	//Serial.readString();
	//Serial.print("AT+PIN5566");
	//Serial.readString();
	//Serial.print("AT+BAUD4");
	//Serial.readString();

	pinMode(sense_pin, INPUT);

	pinMode(4, OUTPUT);
	pinMode(5, OUTPUT);
	pinMode(6, OUTPUT);
	pinMode(7, OUTPUT);	
	digitalWrite(4, LOW);
	digitalWrite(5, LOW);
	digitalWrite(6, LOW);
	digitalWrite(7, LOW);

	for (int i = 0; i < 10; i++)
	{
		pinMode(pins[i], OUTPUT);
		digitalWrite(pins[i], LOW);
	}

	digitalWrite(A5, LOW); //   ""  ,   

	fill_numbers();
	randomSeed(analogRead(A6));
}
unsigned long last_sec = 0;
int hours = 17;
int minutes = 31;

int callibration_second = 1000; //    1 ? 
								//  1000  ..    (    ), 
								//     3.3    5.2,     
								//   1000  %)     
								//   .
int calibration_time_seconds = -1;

int disable_num = -1;
void loop(){
	//begin:
	//  
	int cur_sense = analogRead(sense_pin);
	if (cur_sense > sense_max)
		noTone(pwm_pin);
	else
		tone(pwm_pin, pwm_freq);
	delay(4);
	noTone(pwm_pin);

	//  
	long cur_sec = millis() / callibration_second;
	if (cur_sec != last_sec)
	{
		last_sec = cur_sec;

		if (last_sec % 60 == 0)
		{
			minutes++;
			if (minutes >= 60) {
				hours++;
				minutes = 0;
			}
			if (hours >= 24) hours = 0;
		}

		//     
		if (Serial.available() > 0 && calibration_time_seconds == -1) {
			int cmd = Serial.read();
			if (cmd == 't')
			{
				int n = parceIntFromSerial2();
				Serial.print("OKt"); Serial.print(n); Serial.print("\n"); //Serial.flush(); 
			}
			if (cmd == 'h')
			{
				hours = parceIntFromSerial2();
				Serial.print("OKh"); Serial.print(hours); Serial.print("\n"); //Serial.flush();
			}
			if (cmd == 'm')
			{
				minutes = parceIntFromSerial2();
				Serial.print("OKm"); Serial.print(minutes); Serial.print("\n");//Serial.flush(); 
			}
			if (cmd == 's')
			{
				callibration_second = parceIntFromSerial2();
				Serial.print("OKs"); Serial.print(callibration_second); Serial.print("\n");//Serial.flush();
			}
			if (cmd == 'c')
			{
				calibration_time_seconds = parceIntFromSerial2();
				Serial.print("OKc"); Serial.print(calibration_time_seconds); Serial.print("\n");
				Serial.print("st\n");
				//Serial.flush(); 
			}
		}
		if (calibration_time_seconds == 0)
		{
			Serial.print("en\n");
			//Serial.flush();
		}
		if (calibration_time_seconds >= 0)
			calibration_time_seconds--;

		fill_numbers();
	}

	// 
	for (int cur_pos = 0; cur_pos < 4; cur_pos++)
	{
		if (cur_pos == disable_num) continue;
		digitalWrite(pos_pins[cur_pos], HIGH);
		digitalWrite(pins[numbers[cur_pos]], HIGH);
		delayMicroseconds(1000);
		digitalWrite(pos_pins[cur_pos], LOW);
		digitalWrite(pins[numbers[cur_pos]], LOW);
	}

	digitalWrite(A5, cur_sec % 2 == 0 ? LOW : HIGH);

	make_noise();
	//goto  begin;
}

void fill_numbers()
{
	numbers[0] = hours / 10;
	numbers[1] = hours % 10;
	numbers[2] = minutes / 10;
	numbers[3] = minutes % 10;
}

int parceIntFromSerial2(){
	int v = Serial.parseInt();
	int c = Serial.parseInt();
	if (v % 255 == c) return v;

	Serial.readString();
	Serial.print("ERROR prm=");
	Serial.print(v);
	Serial.print(" cntrlsum=");
	Serial.print(c);
	Serial.print("\n");
	while (Serial.available() < 1);
	Serial.read();
	return parceIntFromSerial2();
}

boolean is_disable_num = false;
boolean is_crazy_nums = false;
void make_noise(){
	if (millis() % 100 < 10)
	{
		is_disable_num = random(20) == 0;
		is_crazy_nums = random(20) == 0;
	}
	else {
		// ***************** is_disable_num
		if (is_disable_num)
		{
			if (disable_num == -1)
				disable_num = random(4);
		}
		else
			disable_num = -1;
		// ********************** is_crazy_nums
		if (is_crazy_nums){

			int rnd_number = random(7);
			int rnd_pos = random(4);
			digitalWrite(pos_pins[rnd_pos], HIGH);
			digitalWrite(pins[numbers[rnd_number]], HIGH);
			delay(1);
			digitalWrite(pos_pins[rnd_pos], LOW);
			digitalWrite(pins[numbers[rnd_number]], LOW);
		}
	}
}
